package envoy.client.net;

import java.util.function.Consumer;
import java.util.logging.Logger;

import envoy.client.event.MessageCreationEvent;
import envoy.data.GroupMessage;
import envoy.data.Message.MessageStatus;
import envoy.event.EventBus;
import envoy.util.EnvoyLog;

/**
 * Project: <strong>envoy-client</strong><br>
 * File: <strong>ReceivedGroupMessageProcessor.java</strong><br>
 * Created: <strong>13.06.2020</strong><br>
 * 
 * @author Maximilian K&auml;fer
 * @since Envoy Client v0.1-beta
 */
public class ReceivedGroupMessageProcessor implements Consumer<GroupMessage> {

	private static final Logger logger = EnvoyLog.getLogger(ReceivedGroupMessageProcessor.class);

	@Override
	public void accept(GroupMessage groupMessage) {
		if (groupMessage.getStatus() == MessageStatus.WAITING || groupMessage.getStatus() == MessageStatus.READ)
			logger.warning("The groupMessage has the unexpected status " + groupMessage.getStatus());

		// Dispatch event
		EventBus.getInstance().dispatch(new MessageCreationEvent(groupMessage));
	}

}
